Attribute VB_Name = "modDefaultPrinter"
Option Compare Database
Option Explicit

Function SetDefaultPrinter()

'from https://learn.microsoft.com/en-us/office/vba/api/access.application.printer

Dim prtDefault As printer

'select a printer from the printers collection as listed using GetDefaultPrinter.
'The collection numbering is zero based.

'change the number as appropriate
Set Application.printer = Application.Printers(6)
' . . . or use the printer name
'Set Application.printer = Application.Printers("YourPrinterNameHere")
 
Set prtDefault = Application.printer
 
With prtDefault
 MsgBox "Device name: " & .DeviceName & vbCrLf & _
    "Driver name: " & .DriverName & vbCrLf & _
    "Port: " & .Port
End With

End Function

Function ChangeDefaultPrinter()

    Dim ptr As printer
    'Get current default printer
    Set ptr = Application.printer
    
    'modify it to a specified printer
    Set Application.printer = Application.Printers("YourPrinterNameHere")
    
    'add code here to print whatever you need to do ...
    
    'optional - restore original default printer
    Set Application.printer = ptr

End Function

Public Function GetDefaultPrinter() As String
      Dim computer As String
      Dim wmiService As Object
      Dim installedPrinters As Variant
      Dim printer As Object
      Dim I As Integer

On Error Resume Next

      'Set the computer. Dot means the computer running the code.
      computer = "."

      'Get the WMI object
      Set wmiService = GetObject("winmgmts:" & "{impersonationLevel=impersonate}!\\" & computer & "\root\cimv2")

      'Retrieve information about the installed printers (by running a query).
      Set installedPrinters = wmiService.ExecQuery("Select * from Win32_Printer")

      'If an error occurs in the previous step, inform the user.
      If Err.Number <> 0 Then
           MsgBox "Could not retrieve the printer information from WMI object!", vbCritical, "WMI Object Error"
           Exit Function
      End If

      'Loop through all the installed printers and get their name. Check if one of them is the default one.
      'Printer status
      'Other (1)
      'Unknown (2)
     'Idle (3)
      'Printing (4)
      'Warmup (5)
      'Stopped Printing(6)
      'Offline (7)

      For Each printer In installedPrinters
            'Write the results to the immediate window
            ' Debug.Print printer.Name, printer.PrinterStatus, printer.Local

           Debug.Print printer.Name, " Local: " & printer.Local & "," & vbTab & " Default: " & printer.Default & _
                 "," & vbTab & " Work Offline: " & printer.workoffline

            If (printer.Default) Then
                  GetDefaultPrinter = printer.Name
                  Debug.Print "====================" & vbCrLf & "Default printer = " & GetDefaultPrinter
                 'Exit For

            End If
      Next printer

End Function

